// Exceptions.h
// by Eric Berdahl
// Copyright 1996,1997 Eric Berdahl
// All rights reserved


#pragma once

// Includes

// Classes defined here

// Classes used here


#define BetelgeuseDebug	0


//------------------------------------------------------------------------------
// Global functions
//------------------------------------------------------------------------------


// FailBeError tests errorCode against B_NO_ERROR, and creates an appropriate
// exception if the check fails.
// NOTE: The current implementation of FailBeError just executes and failed
//       assertion check.
extern void FailBeError(long errorCode);


// Assertion tests the given condition, printing the indicated error message
// if the condition is false.
extern void	Assertion(bool theCondtion, const char* theMessage);


// DebugPrintf takes arguments like printf (from stdio), and sends the output
// to a debugging log (perhaps stderr or a debugger) when debugging is turned
// on for the library.
extern void	DebugPrintf(const char* format, ...);


//------------------------------------------------------------------------------
// BeException interface
//------------------------------------------------------------------------------


class BeException
{
public:
					BeException(long errorCode);
					BeException(const BeException& copy);
	virtual			~BeException();

	long			GetErrorCode() const;

private:
		// Not implemented
	BeException&	operator=(const BeException& assign);

private:
	const long		fErrorCode;
};


//------------------------------------------------------------------------------
// special code for non-debug cases
//------------------------------------------------------------------------------


#if !BetelgeuseDebug
inline
void
Assertion(bool,const char*)
{
	// This space intentionally left blank
}


inline
void
DebugPrintf(const char*,...)
{
	// This space intentionally left blank
}
#endif
