// AtomicLong.cp
// by Eric Berdahl
// Copyright 1997 Eric Berdahl
// All rights reserved
//
// For licensing instructions, see Betelgeuse.h
// For usage instructions, see Synchronization.h


#include "Synchronization.h"


//------------------------------------------------------------------------------
//	AtomicLong implementation
//------------------------------------------------------------------------------


#pragma export on


AtomicLong::AtomicLong(long initialValue)
{
	fValue = initialValue;
}


AtomicLong::~AtomicLong()
{
	// This space intentionally left blank
}


long
AtomicLong::Add(long increment)
{
	long result;

	do
	{
		result = Get();
	} while (!SetConditional(result, result + increment));

	return result;
}


long
AtomicLong::Subtract(long decrement)
{
	return Add(-decrement);
}


#pragma export off
