// MonitorCondition.Be.cp
// by Eric Berdahl
// Copyright 1996,1997 Eric Berdahl
// All rights reserved
//
// For licensing instructions, see Betelgeuse.h
// For usage instructions, see Synchronization.h


#include "Exceptions.h"
#include "Synchronization.h"

#include <Errors.h>
#include <OS.h>

#include <stdio.h>


//------------------------------------------------------------------------------
// MonitorCondition's Be-specific implementation
//------------------------------------------------------------------------------


void
MonitorCondition::PlatformConstructor()
{
	char theName[B_OS_NAME_LENGTH];
	::sprintf(theName, "Condition-%X", (long) this);

	fConditionSemaphore = ::create_sem(0, theName);
	if (fConditionSemaphore < B_NO_ERROR)
	{
		::FailBeError(fConditionSemaphore);
	}
}


void
MonitorCondition::PlatformDestructor()
{
	::FailBeError(::delete_sem(fConditionSemaphore));
}


void
MonitorCondition::PlatformBlock()
{
	::FailBeError(::acquire_sem(fConditionSemaphore));
}


void
MonitorCondition::PlatformUnblock(long howMany)
{
	::FailBeError(::release_sem_etc(fConditionSemaphore, howMany, 0));
}
