// Synchronization.PPC.cp
// by Eric Berdahl
// Copyright 1997 Eric Berdahl
// All rights reserved
//
// For licensing instructions, see Betelgeuse.h
// For usage instructions, see SynchronizationInternal.h


#include "SynchronizationInternal.h"


//------------------------------------------------------------------------------
//	Global functions
//------------------------------------------------------------------------------


bool
CompareAndSwap(long* variable, long currentValue, long newValue)
{
	bool result;

	ReserveEntryPPC theReserve(variable);
	do
	{
		result = (theReserve.Get() == currentValue);

		if (!result)
		{
			break;
		}
	} while (!theReserve.Set(newValue));

	return result;

#if 0
	mr		r7,r3		// shove r3 out of the way for the return value
	li		r3,0		// preload false (variable != currentValue)

@loop
	lwarx	r6,r0,r7	// load and reserve (r0 means 0)
	cmpw	r4,r6		// first 2 operands equal
	bne-	@exit		// skip if not
	stwcx.	r5,r0,r7	// store new value if still reserved (r0 means 0)
	bne-	@loop		// loop if lost reservation
	li		r3,1		// return true (successfull swap)

@exit
	blr					// return
#endif
}

