// CheapReadWriteLockTestProgram.h
// by Eric Berdahl
// Copyright 1997 Eric Berdahl
// All rights reserved

#pragma once

// Includes

#include <Synchronization.h>
#include <Task.h>

// Classes defined here

class CheapReadWriteLockTestProgram;


// Classes used here


//------------------------------------------------------------------------------
// CheapReadWriteLockTestProgram interface
//------------------------------------------------------------------------------


class CheapReadWriteLockTestProgram : public ThreadProgram
{
public:
					CheapReadWriteLockTestProgram();
	virtual			~CheapReadWriteLockTestProgram();

	virtual void	Run();

private:
	struct Data
	{
				Data();
				Data(long maxNumberReaders);
				~Data();
		void	PrintResults(long expectedReaders,
		                     long expectedWriters,
		                     const char* label) const;

		CheapReadWriteLock	fSemaphore;

		MonitorLock			fLock;
		MonitorCondition	fCondition;
		long				fNumberReaders;
		long				fNumberWriters;
	};

private:
	class ReaderTestProgram : public ThreadProgram
	{
	public:
						ReaderTestProgram(Data* theData);
		virtual			~ReaderTestProgram();

		virtual void	Run();

	private:
		Data* const	fData;
	};

	class WriterTestProgram : public ThreadProgram
	{
	public:
						WriterTestProgram(Data* theData);
		virtual			~WriterTestProgram();

		virtual void	Run();

	private:
		Data* const	fData;
	};
};

