// MonitorConditionTestProgram.h
// by Eric Berdahl
// Copyright 1997 Eric Berdahl
// All rights reserved

#pragma once

// Includes

#include <Synchronization.h>
#include <Task.h>


// Classes defined here

class MonitorConditionTestProgram;


// Classes used here


//------------------------------------------------------------------------------
// MonitorConditionTestProgram interface
//------------------------------------------------------------------------------


class MonitorConditionTestProgram : public ThreadProgram
{
public:
					MonitorConditionTestProgram();
	virtual			~MonitorConditionTestProgram();

	virtual void	Run();

private:
	struct Data
	{
		Data();
		~Data();

		long				fProtectedResource;
		MonitorLock			fLock;
		MonitorCondition	fCondition;
	};

private:
	class TestProgram : public ThreadProgram
	{
	public:
						TestProgram(Data* theData);
		virtual			~TestProgram();

		virtual	void	Run();
	private:
		Data* const	fData;
	};
};

