// ReadWriteLockTestProgram.h
// by Eric Berdahl
// Copyright 1997 Eric Berdahl
// All rights reserved

#pragma once

// Includes

#include <Synchronization.h>
#include <Task.h>

// Classes defined here

class ReadWriteLockTestProgram;


// Classes used here


//------------------------------------------------------------------------------
// ReadWriteLockTestProgram interface
//------------------------------------------------------------------------------


class ReadWriteLockTestProgram : public ThreadProgram
{
public:
					ReadWriteLockTestProgram();
	virtual			~ReadWriteLockTestProgram();

	virtual void	Run();

private:
	struct Data
	{
				Data();
				Data(long maxNumberReaders);
				~Data();
		void	PrintResults(long expectedReaders, long expectedWriters) const;

		ReadWriteLock		fSemaphore;

		MonitorLock			fLock;
		MonitorCondition	fCondition;
		long				fNumberReaders;
		long				fNumberWriters;
	};

private:
	class ReaderTestProgram : public ThreadProgram
	{
	public:
						ReaderTestProgram(Data* theData);
		virtual			~ReaderTestProgram();

		virtual void	Run();

	private:
		Data* const	fData;
	};

	class WriterTestProgram : public ThreadProgram
	{
	public:
						WriterTestProgram(Data* theData);
		virtual			~WriterTestProgram();

		virtual void	Run();

	private:
		Data* const	fData;
	};
};

