// ThreadHandleTestProgram.cp
// by Eric Berdahl
// Copyright 1997 Eric Berdahl
// All rights reserved

#include "ThreadHandleTestProgram.h"


//------------------------------------------------------------------------------
// ThreadHandleTestProgram::Data implementation
//------------------------------------------------------------------------------


ThreadHandleTestProgram::Data::Data() :
	fPrepareSuccess(false),
	fRunSuccess(false)
{
	// This space intentionally left blank
}


ThreadHandleTestProgram::Data::~Data()
{
	// This space intentionally left blank
}


//------------------------------------------------------------------------------
// ThreadHandleTestProgram implementation
//------------------------------------------------------------------------------


ThreadHandleTestProgram::ThreadHandleTestProgram() :
	ThreadProgram()
{
	// This space intentionally left blank
}


ThreadHandleTestProgram::~ThreadHandleTestProgram()
{
	// This space intentionally left blank
}


void
ThreadHandleTestProgram::Run()
{
	Data theData;

	::printf("ThreadHandle test: running (approx 5 seconds)...\n");

	ThreadHandle testThread(new TestProgram(&theData));

		// Read the test variable as soon as possible after returning,
		// to sew up any lingering race conditions.
	const bool prepareSuccess = theData.fPrepareSuccess;
	::printf("ThreadHandle test: Prepare ");
	if (prepareSuccess)
	{
		::printf("PASS\n");
	}
	else
	{
		::printf("FAIL\n");
	}

	testThread.WaitForDeathOf();
	const bool runSuccess = theData.fRunSuccess;
	::printf("ThreadHandle test: WaitForDeathOf ");
	if (runSuccess)
	{
		::printf("PASS\n");
	}
	else
	{
		::printf("FAIL\n");
	}

	::printf("ThreadHandle test: IsValid ");
	if (!testThread.IsValid())
	{
		::printf("PASS\n");
	}
	else
	{
		::printf("FAIL\n");
	}

	::printf("ThreadHandle test: completed.\n");
}


//------------------------------------------------------------------------------
// ThreadHandleTestProgram::TestProgram implementation
//------------------------------------------------------------------------------


ThreadHandleTestProgram::TestProgram::TestProgram(Data* theData) :
	ThreadProgram(),
	fData(theData)
{
	// This space intentionally left blank
}


ThreadHandleTestProgram::TestProgram::~TestProgram()
{
	// This space intentionally left blank
}


void
ThreadHandleTestProgram::TestProgram::Prepare()
{
	ThreadProgram::Prepare();

	const long kSeconds = 1000000;
	::snooze(2*kSeconds);

	fData->fPrepareSuccess = true;
}


void
ThreadHandleTestProgram::TestProgram::Run()
{
	const long kSeconds = 1000000;
	::snooze(2*kSeconds);

	fData->fRunSuccess = true;
}


