// ThreadHandleTestProgram.h
// by Eric Berdahl
// Copyright 1997 Eric Berdahl
// All rights reserved

#pragma once

// Includes

#include <Task.h>


// Classes defined here

class ThreadHandleTestProgram;


// Classes used here


//------------------------------------------------------------------------------
// ThreadHandleTestProgram interface
//------------------------------------------------------------------------------


class ThreadHandleTestProgram : public ThreadProgram
{
public:
					ThreadHandleTestProgram();
	virtual			~ThreadHandleTestProgram();

	virtual void	Run();

private:
	struct Data
	{
		Data();
		~Data();

		bool	fPrepareSuccess;
		bool	fRunSuccess;
	};

private:
	class TestProgram : public ThreadProgram
	{
	public:
						TestProgram(Data* theData);
		virtual			~TestProgram();
		virtual void	Prepare();
		virtual void	Run();

	private:
		Data* const	fData;
	};
};

